#    DataFileVariableCreationExample.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia. All rights reserved.
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#


###############################
#This script creates and easy to use data variable showing the proper syntax
#This is done using regular free Energies

from gibbs.variables import RegularFreeEnergyVariable as RFE

FILE=None

def _calculate(points, DG, Temperature, stepsLoopX, varY=None, varX=None):
    from numpy import zeros
    calcArray=zeros(stepsLoopX, 'd')
    DG.evalf(freeEnergyArray=calcArray, points=points, arraylength=len(points), xsteps=len(points), phaseNumber=0, varX=None, varY=None, yVal=Temperature)
    return calcArray
    
def _getPoints(Nx,min=0., max=1.):
    from numpy import arange
    points=arange(min, max, 1. / float(Nx), 'd')
    return points
    
def changeFile(filename='data.gbs'):
    global FILE
    if FILE is not None:
        FILE.close()
    FILE=open(filename,'w')
    FILE.write(filename[:-4])
    FILE.write('\n')
    FILE.write('########\n')
    FILE.write('%columns: \n')
    FILE.write('C(float)\nDelta_G(float)\nTemp(int)\nPhase(str)\n')
    FILE.write('########\n')
    FILE.write('%constants:\n')
    FILE.write('author(string):tomcool\n')
    FILE.write('date(string):9-12-2009\n')
    FILE.write('Pressure(int):10000\n')
    FILE.write('%data\n')
    
def closeFile():
    global FILE
    FILE.close()
    FILE=None
    
    
changeFile('DataFileVariableData.gbs')
z=range(300, 1500, 10)
points=_getPoints(400)

DG1=RFE(omega=10000, delta_Ha=8000, delta_Hb=12000, Tma=800, Tmb=1200)
DG2=RFE(omega=10000, delta_Ha=0,    delta_Hb=0,     Tma=800, Tmb=1200)

calc=_calculate(points, DG1, 1000, 400)
for i in z:
    calc1=_calculate(points, DG1, i, 400)
    calc2=_calculate(points, DG2, i, 400)
    for j in range(len(points)):
        FILE.write('%f  %f  %i  %s\n'%(points[j], calc1[j], i, 'Phase1'))
    for j in range(len(points)):
        FILE.write('%f  %f  %i  %s\n'%(points[j], calc2[j], i, 'Phase2'))
FILE.close()
