#
#  PhaseDiagram+C+Matplotlib.py
#  gibbs
#
#  Created by Thomas Cool on 9/19/09.
#  Copyright 2009 Thomas Cool, R. Edwin Garcia. All rights reserved.
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    gibbs is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with gibbs.  If not, see <http://www.gnu.org/licenses/>.

#
# Simple Example creating a PhaseDiagram using C regular free energy variables
# and plotting using matplotlib

from gibbs.variables import RegularFreeEnergyVariable
from gibbs.solvers.qhsolver.qhbinarysolver import PhaseDiagramSolver
from gibbs.viewers import MatplotlibViewer

#define regular free energy variables

DG1 = RegularFreeEnergyVariable(omega=-5000, delta_Ha=11940, delta_Hb=24263, Tma=1329, Tmb=2135)
DG2 = RegularFreeEnergyVariable(omega=247,   delta_Ha=0,     delta_Hb=7280,  Tma=4000, Tmb=-3000)
#solve for the phase diagram
Solver = PhaseDiagramSolver(DG=[DG1, DG2],
        x = [0, 1, 200], 
        y= [300, 2000, 400])

#display the phase diagram

Viewer = MatplotlibViewer()
Viewer.plot(vars=Solver, mode='show', xlabel='Composition', ylabel='Temp')
