#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

from gibbs.variables import TernaryRegularFreeEnergyVariable
from gibbs.viewers.matplotlib.matplotlibTernaryViewer import MatplotlibTernaryViewer as TV
from gibbs.viewers import MatplotlibViewer
a=TernaryRegularFreeEnergyVariable(1000,2000,0,300,200,100,20000,3000,5000,5000)
b=TernaryRegularFreeEnergyVariable(1000,2000,0,100,200,300,10000,15000,10000,5000)
c=TernaryRegularFreeEnergyVariable(1000,2000,0,100,400,300,13000,0,0,0)
from gibbs.solvers.qhsolver.qhTernarySolver import CommonTangentSolver
from numpy import arange,array
import time
arr=arange(0,1,0.01)

mat=arange(50,1100,10.0)
v=TV(figureNumber=1)
m=MatplotlibViewer(figureNumber=2)
#mat=[400.0]
for h in mat:
    t1=time.time()
    x1=[]
    x2=[]
    for i in arr:
        solver=CommonTangentSolver(x=[0,1,200],y=[h],x2=i,variables=None,DG=[a,b,c])
        for j in range(len(solver.Px)):
            x1.append(solver.Px[j])
            x2.append(solver.Py[j])
            
        solver=CommonTangentSolver(x=[0,1,200],y=[h],x1=i,variables=None,DG=[a,b,c])
        for j in range(len(solver.Px)):
            x1.append(solver.Px[j])
            x2.append(solver.Py[j])
            
        solver=CommonTangentSolver(x=[0,1,200],y=[h],x3=i,variables=None,DG=[a,b,c])
        for j in range(len(solver.Px)):
            x1.append(solver.Px[j])
            x2.append(solver.Py[j])
            
    farr=array([x1,x2])
    farr=farr.transpose()
    v(vars=farr,title='T=%.1f'%h)
    v.save('pngTemp/ternaryTemp.png',dpi=200)
    t2=time.time()
    print 'temp: %.1f, time: %.3f'%(h,t2-t1)
