#
#  guiPhaseSolverC.py
#  Swig_Test
#
#  Created by Thomas on 9/25/09.
#  Copyright (c) 2009. All rights reserved.
#
# example:  creates a small gui in vkmllive, creates a solver and runs it
#           uses the Semi-Regular free energy generator found in QHSolve
#           draws the free Energy Lines and the common tangents

from gibbs.tools.gui import VKMLgui



from gibbs.variables import RegularFreeEnergyVariable as RFE
from gibbs.solvers.qhsolver.qhbinarysolver import CommonTangentSolver
from gibbs.viewers import MatplotlibViewer

MatplotlibViewer= MatplotlibViewer(title='Temperature',limits=[-0.05,1.05,None,None])
def callback(aspectRatio,omega_one,omega_two,Temperature):

    DG1=RFE(omega=omega_one,delta_Ha=8000,delta_Hb=12000,Tma=800,Tmb=1200)
    DG2=RFE(omega=omega_two,delta_Ha=0,delta_Hb=0,Tma=800,Tmb=1200)
    

    #pass them in a list

    Solver=CommonTangentSolver(DG=[DG1,DG2],
               x=[0,1,300],
               y=[Temperature])

    #display the phase diagram
    MatplotlibViewer.plot(vars=Solver,aspectRatio=aspectRatio)
    MatplotlibViewer.save('1.eps',overwrite=True)

	
    
if __name__=='__main__':
    p=VKMLgui.Parser(title='QHSolver')
    m1=VKMLgui.Menu(title='x Properties',parser=p)
    VKMLgui.Parameter(name='Temperature',menu=m1,variable=int,default = 850, interval=(0,2000))
    VKMLgui.Parameter(name='omega_one',menu=m1,variable=int,default = 0, interval=(-30000,30000))
    VKMLgui.Parameter(name='omega_two',menu=m1,variable=int,default = 10000, interval=(-30000,30000))
#    VKMLgui.Parameter(name='path',menu=m1,variable=str,default='')
#    VKMLgui.Parameter(name='format',menu=m1,variable=str,default='ps')
#    VKMLgui.Parameter(name='title',menu=m1,variable=str,default='%yVar vs %xVar')
    VKMLgui.Parameter(name='aspectRatio',menu=m1,variable=float,default=1.,interval=(0.1,10))
    #VKMLgui.Parameter(name='save',menu=m1,variable='function',default=saveImage)


    p.add_command(callback)



    p.run()
