#    DataFileVariableUse.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    gibbs is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

from gibbs.variables import RegularFreeEnergyVariable, DataFileVariable
from gibbs.solvers.qhsolver.qhbinarysolver import CommonTangentSolver, PhaseDiagramSolver
from gibbs.viewers import GnuplotViewer
from sympy import log
import time

#define variables for free energy equations

#free energy functions
DG1=RegularFreeEnergyVariable(omega=20000,delta_Ha=8000,delta_Hb=12000,Tma=800,Tmb=1200)
DG3=RegularFreeEnergyVariable(omega=10000,delta_Ha=0,delta_Hb=0,Tma=800,Tmb=1200)
t1=time.time()
DG2=DataFileVariable("DataFileVariableData.gbs")
t3=time.time()
DG2_Phase2=DG2(Phase='Phase2')
Solver=CommonTangentSolver(DG=[DG1, DG2_Phase2],
                variables = ['C','Temp'],
                x=[0,1,200],
                y=[1015])
DG2.levels('Phase')
t2=time.time()
Viewer=GnuplotViewer(vars=Solver,title='With Interpolation')
Viewer.plot()
t4=time.time()
Solver2=CommonTangentSolver(DG=[DG1, DG3],
                variables = ['C','Temp'],
                x=[0,1,200],
                y=[1015])
Viewer2=GnuplotViewer(vars=Solver2,title='Without Interpolation')
Viewer2.plot()
t5=time.time()


Solver3=PhaseDiagramSolver(DG=[DG1,DG2_Phase2],
                variables=['C','Temp'],
                x=[0,1,200],y=[300,1300,300])
Viewer3=GnuplotViewer(vars=Solver3,title='Phase Diagram With Interpolation')
Viewer3.plot()
print "time to load for 3.5MB size file: %.3f   time to generate: %.3f  total time to use: %.3f\n time to generate C: %.3f"%(t3-t1,t2-t3,t2-t1,t5-t4)