#
#
#  PhaseDiagram+C+loop+matplotlib_gnuplot.py
#  gibbs
#
#  Created by Thomas Cool on 10/14/09.
#  Copyright 2009 Thomas Cool. All rights reserved.
#

# example:  same as PhaseDiagram+C+loop+matplotlib_gnuplot.py
#           please refer to that file
#           except it also saves the images generated





from gibbs.variables import RegularFreeEnergyVariable
from gibbs.solvers.qhsolver.qhbinarysolver import PhaseDiagramSolver
from gibbs.viewers import GnuplotViewer,MatplotlibViewer


def loop(viewer='matplotlib'):
    if viewer not in ['gnuplot','matplotlib']:
        viewer='gnuplot'
    if viewer=='gnuplot':
        Viewer=GnuplotViewer(title='Regular C')
    elif viewer=='matplotlib':
        Viewer=MatplotlibViewer()
    for i in range(500):

        DG1=RegularFreeEnergyVariable(omega=120*i-30000,delta_Ha=8000,delta_Hb=12000,Tma=800,Tmb=1200) # define equivalent Regular Energy
        
        DG2=RegularFreeEnergyVariable(omega=15000,delta_Ha=0,delta_Hb=0,Tma=800,Tmb=1200)
        

     
        bb=PhaseDiagramSolver(DG=[DG1,DG2],
                   x=[0,1,400],
                   y=[140,1800,500])
        
        Viewer.plot(vars=bb,title='$\Omega1=%i$'%(120*i-30000),xlabel='%B',ylabel='Temperature $(\degree C)$',xmode='percent')
        
        #saving the image generated by the viewer
        Viewer.save(file='temp/Image.png')

    
if __name__=='__main__':
    loop(viewer='matplotlib')

