#
#
#  PhaseDiagram+C+loop+matplotlib_gnuplot.py
#  gibbs
#
#  Created by Thomas Cool on 10/14/09.
#  Copyright 2009 Thomas Cool. All rights reserved.
#

# example:  Does not create a gui
#           Creates 2 regular free energies and iterates 1000 times over a varying omega
#           for the first free energy




from gibbs.variables import RegularFreeEnergyVariable
from gibbs.solvers.qhsolver.qhbinarysolver import PhaseDiagramSolver
from gibbs.viewers import GnuplotViewer,MatplotlibViewer
import time


def loop(viewer='gnuplot'):
    if viewer not in ['gnuplot','matplotlib']:
        viewer='gnuplot'
    if viewer=='gnuplot':
        Viewer=GnuplotViewer(title='Regular C')
    elif viewer=='matplotlib':
        Viewer=MatplotlibViewer(title='Regular C')
    for i in range(1000):
        
        DG1=RegularFreeEnergyVariable(omega=60*i-30000,delta_Ha=8000,delta_Hb=12000,Tma=800,Tmb=1200) # define equivalent Regular Energy
        
        DG2=RegularFreeEnergyVariable(omega=15000,delta_Ha=0,delta_Hb=0,Tma=800,Tmb=1200)
        

     
        Solver=PhaseDiagramSolver(DG=[DG1,DG2],
                   x=[0,1,200],
                   y=[180,1700,300])

        Viewer.plot(vars=Solver)
    
if __name__=='__main__':
    loop(viewer='gnuplot')

