#
#  PhaseDiagram+C+Matplotlib.py
#  Swig_Test
#
#  Created by Thomas Cool on 9/19/09.
#  Copyright (c) 2009 Thomas Cool. All rights reserved.
#
# Simple Example creating a PhaseDiagram using C regular free energy variables
# and plotting using matplotlib


from gibbs.variables import RegularFreeEnergyVariable
from gibbs.solvers.qhsolver.qhbinarysolver import PhaseDiagramSolver
from gibbs.viewers import MatplotlibViewer

#define regular free energy variables

DG1=RegularFreeEnergyVariable(omega=-5000,delta_Ha=11940,delta_Hb=24263,Tma=1329,Tmb=2135)
DG2=RegularFreeEnergyVariable(omega=247,delta_Ha=0,delta_Hb=7280,Tma=4000,Tmb=-3000)
#solve for the phase diagram
Solver=PhaseDiagramSolver(DG=[DG1, DG2],
        x = [0, 1, 200], 
        y= [300, 2000, 400])

#display the phase diagram

Viewer=MatplotlibViewer()
Viewer.plot(vars=Solver,mode='show',xlabel='Composition',ylabel='Temp')