#    ThermocalcVariableExample-WIP.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    gibbs is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#
from gibbs.viewers import MatplotlibViewer
from gibbs.variables import TCDBVariable
from time import time
#a=TCDBVariable("sncuag.tdb")
a=TCDBVariable("agcu.tdb")
#print '##################ELEMENTS###################'
#print a.elements
print '###################PHASES####################'
#print a.phases.keys()
for i in a.phases.keys():
    print i, a.phases[i]['parameters'].keys()
#print '##################FUNCTIONS##################'
#b=a.functions
#for i in b.keys():
#    print i,"\n",b[i]
#print '#################PARAMETERS##################'
#b=a.parameters
#for i in b.keys():
#    print i,"\n",b[i]
#print '####################KEYS#####################'
#print "Phases:\n",a.Phases()
#print "Parameters:\n",a.Parameters()
#print "Functions:\n",a.Functions()
#print "Elements:\n",a.Elements()

#print a
a.setPhase("FCC_A1")
#a.setComponents(["CU","AG"])
c=a.extractCopy()
b=TCDBVariable("agcu.tdb")
b.setPhase("LIQUID")
#b.setComponents(["CU","AG"])
c.setPhase("LIQUID")
#c.setComponents(["CU","AG"])
from copy import copy
d=copy(c)
e=a.copy()
#print a
#print "equation for 300K:"
#t1=time()
#a.eval(yVal=300)
#t2=time()
#print "equation for 2000K:"
#t3=time()
#print a.eval(yVal=2000)
#t4=time()
#print "equation for 2100K:"
#t5=time()
#print a.eval(yVal=2100)
#t6=time()

#print t2-t1,t4-t3,t6-t5
from gibbs.variables import RegularFreeEnergyVariable as RFE
from gibbs.solvers.qhsolver.qhbinarysolver import CommonTangentSolver
from gibbs.solvers.qhsolver.qhbinarysolver import PhaseDiagramSolver
DG1=RFE(omega=1000,delta_Ha=8000,delta_Hb=12000,Tma=800,Tmb=1200)
t7=time()
ee=c+DG1
print a.Phases()


Solver=PhaseDiagramSolver(DG=[a,d],
                                x=[0,1,400],            #defines range for x-axis   
                                y=[300,1500,400],    #defines range for y-axis
                                PB='None')              #define progress bar type
t8=time()
print "time to compute phase diagram: %s"%str(t8-t7)
from gibbs.viewers import GnuplotViewer

Viewer2=GnuplotViewer(vars=Solver)
Viewer2.plot()
Viewer=GnuplotViewer()

def calc(Temp=1000):
    Solver=CommonTangentSolver(DG=[a,c,ee],
               x=[0,1,300],
               y=[Temp])
    Viewer.plot(vars=Solver)
from gibbs.tools.gui import VKMLgui
p=VKMLgui.Parser(title='TCDBVar',interactive=1)
m1=VKMLgui.Menu(title='Temp',parser=p)
VKMLgui.Parameter(name='Temp',menu=m1,variable=int,default=300,interval=(300,4000))
p.add_command(calc)
p.run()

