from variable import Variable
from sympy import ln
from fipy import CellVariable, Grid2D
import numpy as numerix

	
T = Variable ("T")
x = Variable ("x")
R = Variable ("R")
omega = Variable ("omega")
	
numberOfElements = 10
nx = int(numerix.sqrt(numberOfElements))
ny = int(numerix.sqrt(numberOfElements))
dx = 1.0/float(nx)
dy = 1.0/float(ny)
	
mesh = Grid2D(dx = dx, dy = dy, nx = nx, ny = ny)
	
phi = CellVariable(name = "phi",
                   mesh = mesh,
                   value = 0.6)
	
Tphi = CellVariable(name = "T",
                   mesh = mesh,
                   value = 300.0)

	
DG = Variable(omega*x*(1.0 - x) + R*T*x*ln(x) + R*T*(1.0 - x)*ln(1.0 - x))


DG_Value = DG(R=8.134, omega=10000.0, x=phi, T=Tphi)
print DG_Value













