from variable import Variable
from sympy import ln
from fipy import CellVariable, Grid2D
import numpy as numerix

	
T = Variable ("T")
x = Variable ("x")
R = Variable ("R")
omega = Variable ("omega")
	
numberOfElements = 10
nx = int(numerix.sqrt(numberOfElements))
ny = int(numerix.sqrt(numberOfElements))
dx = 1.0/float(nx)
dy = 1.0/float(ny)
	
mesh = Grid2D(dx = dx, dy = dy, nx = nx, ny = ny)
	
phi = CellVariable(name = "phi",
                   mesh = mesh,
                   value = 0.6)
	
Tphi = CellVariable(name = "T",
                   mesh = mesh,
                   value = 300.0)

##Free Energy Equation
DG = omega*x*(1.0 - x) + R*T*x*ln(x) + R*T*(1.0 - x)*ln(1.0 - x)
print "Free Energy Equation DG =", DG

##Changes DG into a Variable instance	
DG_Variable = Variable(DG)

##Substitutes DG_Variable 
DG_Value = DG_Variable(R=8.134, omega=10000.0)
print "Substitutes R & omega:", DG_Value

##Takes the derivative
dGdx = DG_Value.diff(x)
print "Derivative of Free Energy dGdx =", dGdx

##Changes dGdx into a Variable instance
dGdx_Variable = Variable(dGdx)

##Substitutes dGdx_Variable with Fipy arrays
dGdx_phi = dGdx_Variable(x=phi, T=Tphi)
print "Substitutes x & T with Fipy arrays:", dGdx_phi















