from gibbs.variable import Variable
from sympy import ln 
from fipy import CellVariable, Grid2D

T = Variable ("T")
x = Variable ("x")
R = Variable ("R")
omega = Variable ("omega")

numberOfElements = 10
nx = int(numerix.sqrt(numberOfElements))
ny = int(numerix.sqrt(numberOfElements))
dx = 1.0/float(nx)
dy = 1.0/float(ny)

mesh = Grid2D(dx = dx, dy = dy, nx = nx, ny = ny)

phi = CellVariable(name = "phi",
                   mesh = mesh,
                   value = 0)

Tphi = CellVariable(name = "T",
                   mesh = mesh,
                   value = 300)

DG = R*T*x*ln(x) + R*(1 - x)*ln(1 - x) + omega*x*(1 - x)
print DG ## DG is purely symbolic

print DG(R=8.134) ## DG has ONE numerical value

dGdx = F.diff(x) ## takes the symbolic derivative
dGphi = dGdx(x = phi, T = Tphi) ## converts the derivative of the free energy to a phase field variable


