#
#  pythonConvexHull.py
#  Swig_Test
#
#  Created by Thomas Cool on 9/19/09.
#  Copyright (c) 2009 Thomas Cool. All rights reserved.
#
# Simple Example using sympy to compute the freeEnergies
# in this case sympy is the time limiting factor
# in DG equations Temperature has to be replaced by Temp and 
# x is the coordinate accross the phase diagram

from gibbs.variables import PyVariable
from gibbs.tools.functions import xlogx


#define variables for free energy equations
x=PyVariable('x')
R=PyVariable('R')
Temp=PyVariable('Temp')
omega=PyVariable('omega')
delta_Ha=PyVariable('delta_Ha')
delta_Hb=PyVariable('delta_Hb')
Tma=PyVariable('Tma')
Tmb=PyVariable('Tmb')

# symbolic free energy function representation
DG=PyVariable(omega*x*(1.0-x)+R*Temp*(xlogx(x)+xlogx(1.0-x))+(1.0-x)*(delta_Ha-Temp*delta_Ha/Tma)+x*(delta_Hb-Temp*delta_Hb/Tmb))
print "DS=", DG.diff(Temp)

#print "DG_taylor=", DG.series(x, 1, 5)


# free energy function substitutions
DG(omega=-22880,R=8.314,delta_Ha=11940,delta_Hb=24263,Tma=1329,Tmb=2135)
DGSum = DG+DG
if isinstance(DGSum,PyVariable):
    print "###"
    print DGSum,"is a PyVariable too"
    print DGSum.diff(x)
    print "###"
    
print "dDG/dx=", DG.diff(x)
#print "DG_taylor=", DG.series(x, 1, 5)



