#
#
# Filename: variableCreation.py
# 
#
# AUTHOR        DATE MODIFIED       
# ------        -------------
#  TCC           19-10-2009
#
#Shows how to create examples


from gibbs.variables import IdealFreeEnergyVariable, PyVariable, RegularFreeEnergyVariable

#creating an ideal free energy variable:
print "\ncreating an IdealFreeEnergyVariable with name ideal and parameters: \ndelta_Ha=%i, delta_Hb=%i, Tma=%i, Tmb=%i"%(8000,12000,800,1200)
ideal=IdealFreeEnergyVariable(delta_Ha=8000,
                                delta_Hb=12000,
                                Tma=800,
                                Tmb=1200)
print "printing ideal: %s"%ideal
                                
#Python Variables Require a bit more work
#you first need to create the "variable's variables"
print "creation of Python Variable (PyVariable)"
print "create x=PyVariable('x') and Omega=PyVariable('Omega')"
x=PyVariable('x')

Omega=PyVariable('Omega')
print "\n"
print "combine them in PyVariable form: PythonTerm=PyVariable(Omega*x*(1.0-x))"
PythonTerm=PyVariable(Omega*x*(1.0-x))
print "\nPythonTerm: %s"%PythonTerm
print "\n"
#It is also possible to replace omega at two different times:
#   if you pass Omega in the variables Parameter of the Solver, it will be a temporary replacement (duration of the Hull/Phase Diagram)
#   if you pass Omega now, it will be a permanent replacement for the duration of the existence of the Variable:
print "\nReplacing Omega with 10000 in PythonTerm:\nPythonTerm(Omega=10000)"
PythonTerm(Omega=10000) # This replaces Omega permamently with 10000
print "\nPythonTerm: %s"%PythonTerm
print "\n"

#We can also create built in regular free energy variables
print "\ncreating an RegularFreeEnergyVariable with name ideal and parameters: \nomega=%i delta_Ha=%i, delta_Hb=%i, Tma=%i, Tmb=%i"%(10000,0,0,800,1200)
print "regular=RegularFreeEnergyVariable(omega=10000,delta_Ha=0,delta_Hb=0,Tma=800,Tmb=1200)"
regular=RegularFreeEnergyVariable(omega=10000,delta_Ha=0,delta_Hb=0,Tma=800,Tmb=1200)
print "\nregular: %s"%regular
print "\n"

#Finally The Variables can also be added together:
print "\nadding Variables PythonTerm and ideal into sumVar\nsumVar=ideal+PythonTerm"
sumVar=ideal+PythonTerm
print "\nsumVar: %s"%sumVar
print "sumVar and regular should now be the equivalent..."



