/*
 *  QHSemiRegularGenerator.h
 *  Swig_Test
 *
 *  Created by Thomas on 9/18/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <stdlib.h>
#include <math.h>

struct semi_reg_struct
{
	double omega;
	double delta_Ha;
	double delta_Hb;
	double temp_m_a;
	double temp_m_b;
};
typedef struct semi_reg_struct semi_reg_struct;

/***********************************
 / calculates the free energies for certain materials and puts them in the proper free energy array
 / points				array containing all the free energies for the materials		(see: getPointsArray)
 / freeEnergy			array to fill initialized with same amount of elements as points
 / nb_pts				is the total number of data points per material (ex: 200)
 / elt_number			number of the material (should not be bigger than nb_elements in getPointsArray
 / totalmax				is number of points for which points is malloc'ed.				(see: getPointsArray)
 /**********************************/
extern int calculateFreeEnergy(double *points, double *freeEnergy, int totalmax, int nb_pts, int elt_numbers, semi_reg_struct phase, double Temp );


extern semi_reg_struct setPhase(double omega, double delta_Ha, double delta_Hb, double temp_m_a, double temp_m_b);
