/*
 *  QHRegularGeneratorC.h
 *  Swig_Test
 *
 *  Created by Thomas Cool on 9/30/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <stdlib.h>
#include <math.h>

struct quasi_reg_structP
{
	double omega;
	double delta_Ha;
	double delta_Hb;
	double temp_m_a;
	double temp_m_b;
    double temp_zero;
};
typedef struct quasi_reg_structP quasi_reg_structP;

/***********************************
 / calculates the free energies for certain materials and puts them in the proper free energy array
 / points				array containing all the free energies for the materials		(see: getPointsArray)
 / freeEnergy			array to fill initialized with same amount of elements as points
 / nb_pts				is the total number of data points per material (ex: 200)
 / elt_number			number of the material (should not be bigger than nb_elements in getPointsArray
 / totalmax				is number of points for which points is malloc'ed.				(see: getPointsArray)
 /**********************************/
extern int calculateFreeEnergy(double *points, double *freeEnergy, int totalmax, int nb_pts, int elt_numbers, quasi_reg_structP phase, double Temp );


extern quasi_reg_structP setPhase(double omega, double delta_Ha, double delta_Hb, double temp_m_a, double temp_m_b,double temp_zero);