#
#  Variable.py
#  Swig_Test
#
#  Created by Thomas on 9/16/09.
#  Based on Code from Professor Garcia
#  Copyright (c) 2009 Thomas Cool. All rights reserved.
#
#  Purdue University, 47906 Indiana, USA

from sympy import Symbol
from sympy.core.basic import Basic
from QHSympyFunctions import xlogx

class Variable(Basic):
    
    def __new__(cls, name):
        if isinstance(name, Basic):
            obj = Basic.__new__(cls)
            obj.name = name
            return obj
        else:
            return Symbol(name)
    
    def __call__(self, **kwargs):
        eq = [self.name]
        result = []
        for key in kwargs:
            if type(kwargs[key]) in (type(1), type(1.)):
                kwargs[key] = [kwargs[key]]
            
            if len(eq)>1 and len(kwargs[key])>1:
                sequence = kwargs[key]
                for i in range(len(eq)):
                    temp = eq[i]._subs_old_new(key, sequence[i])
                    result.append(temp)
            else:
                for i in range(len(eq)):
                    for sequence in kwargs[key]:
                        temp = eq[i]._subs_old_new(key, sequence)
                        result.append(temp)
            eq = result
            result = []
        if len(eq)==1:
            eq = eq[0]
        return eq
        
        
