from gibbs.solvers.qhsolver.qhsolvercore import QHSolverCore
from gibbs.solvers.qhsolver.qhTernarySolver.ternarySolver import QHTernarySolver
from gibbs.solvers.qhsolver import QHSolve
import time

#import QHSolve


class PhaseDiagramSolver(QHTernarySolver):
    def __init__(self,x=[0,1,200],y=[650,1300,150],x2=0.0,variables=None,DG=None,ProgressBar='None',**kwargs):
        QHTernarySolver.__init__(self,x=x,y=y,x2=x2,variables=variables,DG=DG,ProgressBar=ProgressBar)
        self._solve()


        
    def _solve(self, **kwargs):
        from gibbs.tools import ProgressBar
        from numpy import arange,argmin,argmax
        
        Temp,maxLoopY,stepsLoopY = self._returnValY()
        
        
        minLoopX,maxLoopX,stepsLoopX =self._returnValX()
            
 
        phases = self._getNbPhases()                                        #number of phases from FEParameterList
        varY=self._returnVariableY()
        varX=self._returnVariableX()
            
            
                 #get points array
        totalmax=stepsLoopX*phases                                                #total number of free energies for Qhull        
        stepsize=float(maxLoopY-minLoopY)/stepsLoopY                            #stepsize for temperature increase
        self.stepsize=stepsize
        prog=ProgressBar(type=self.PB, min=minLoopY,max=maxLoopY)
            
        oldtan=0
        tempList=[]
        xtempList=[]
        for x2 in arange(0,1,stepsize):                         #main loop
            stepsLoopX=int((1.0-x2)*stepsLoopX)
            minLoopX=0.0
            maxLoopX=1.0-self.x2
            points = self._getPoints(phases,stepsLoopX,minLoopX,maxLoopX)
            prog(Temp)
            
            freeEnergy = self._calculate(points,float(Temp),varY,varX,stepsLoopX,x2)
            t3=time.time()              
            c=QHSolve.QHSolver(Temp,totalmax,phases,points,freeEnergy)


            minV=0
            maxV=0

                
                
            ######## Triple Point Logic
            ######### end triple point logic
            

            for j in range(c.nb_tangents):                                             #add points to Lists
                    self.P.append(QHSolve.getDouble(c.xx,j))
                    self.L.append(x2)

            
            QHSolve.freeStruct(c)
            #QHSolve.delete_doubleArrayFct(freeEnergy)

        #QHSolve.delete_doubleArrayFct(points)


        prog.close()
        t2=time.time()

    def type(self):
        return '2Dimensional'

        

    
