#
#  solvercore.py
#  gibbs
#
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

import os
from gibbs.tools.utils import CustomException, _mkdir
#from gibbs.variables.generation.generation import Generation


class SolverCore:
    def __init__(self,x=[0,1,300],y=[300,1300,300],DG=[],variables=None):
        
        self.xProperties=x
        self.yProperties=y
        self.variables=(variables or ['x','Temp'])
        self.DG=DG
        

        
    def _returnValX(self,returnType='tuple'):
        if returnType not in ['tuple','list']:
            returnType='tuple'
        maxLoopX      = self.xProperties[1]
        minLoopX      = self.xProperties[0]
        stepsLoopX    = self.xProperties[2]
            
        if returnType=='tuple':
            return minLoopX,maxLoopX,stepsLoopX
        elif returnType=='list':
            return [minLoopX,maxLoopX,stepsLoopX]
            
    def _returnVariableX(self):
        if self.variables==None or len(self.variables)<1:
            return ''
        if type(self.variables[0]) is type([]):
            return self.variables[0][0]
        return self.variables[0];
        
    def _returnVariableY(self):
        if self.variables==None or len(self.variables)<2:
            return ''
        if type(self.variables[1]) is type([]):
            return self.variables[1][0]
        return self.variables[1]
            
    def _returnValY(self,returnType='tuple'):
        if returnType not in ['tuple','list']:
            returnType='tuple'
        minLoopY      = self.yProperties[0]
        if len(self.yProperties)>1:
            maxLoopY  = self.yProperties[1]
        else:
            maxLoopY  = 0
        if len(self.yProperties)>2:
            stepsLoopY= self.yProperties[2]
        else:
            stepsLoopY=0
        if returnType=='tuple':
            return minLoopY,maxLoopY,stepsLoopY
        elif returnType=='list':
            return [minLoopY,maxLoopY,stepsLoopY]
#    def write(self,filename='data.gbs',append=False)
            
#    def _getFigTitle(self,type='',**kwargs):
#        if kwargs.has_key('title') and kwargs['title']!=None:
#            rawTitle=kwargs['title']
#            rawTitle=rawTitle.replace('%yVar',str(self._returnVariableY()))
#            rawTitle=rawTitle.replace('%xVar',str(self._returnVariableX()))
#            rawTitle=rawTitle.replace('%xMin',str(self._returnValX(returnType='list')[0]))
#            rawTitle=rawTitle.replace('%yMin',str(self._returnValY(returnType='list')[0]))
#            rawTitle=rawTitle.replace('%yMax',str(self._returnValY(returnType='list')[1]))
#            rawTitle=rawTitle.replace('%ySteps',str(self._returnValY(returnType='list')[2]))
#            rawTitle=rawTitle.replace('%xMax',str(self._returnValX(returnType='list')[1]))
#            rawTitle=rawTitle.replace('%xSteps',str(self._returnValX(returnType='list')[2]))
#            title=rawTitle
#        else:
#            if type=='Hull' or type=='1Dimensional':
#                title='Hull at %s'%str(self._returnValY(returnType='list')[0])
#            elif type=='save' or type=='2Dimensional':
#                title='Gibbs_Image'
#            else:
#                title='Gibbs_Image'
#        return title
            
            

        

        
            
        
                
                    
        


    
            
