import Tkinter
class PB:

    # Create Progress Bar
    def __init__(self, width, height):
        self.__root = Tkinter.Tk()
        #self.__root.withdraw()
        self.__root.resizable(False, False)
        self.__root.title('Progress Bar')
        self.__canvas = Tkinter.Canvas(self.__root, width=width, height=height)
        self.__canvas.grid()
        self.__width = width
        self.__height = height
        self._t = self.__canvas.create_text(int(self.__width)/2,int(self.__height)/2, text='')
        self._r = self.__canvas.create_rectangle(0, 0, self.__width * 0,self.__height, fill='blue')
        self.update(0.0)
        self.close()
        self.open()

    # Open Progress Bar
    def open(self):
        self.__root.deiconify()

    # Close Progress Bar
    def close(self):
        self.__root.withdraw()

    # Update Progress Bar
    def update(self, ratio,text=None):
        self.__canvas.delete(Tkinter.ALL)
        self._r = self.__canvas.create_rectangle(0, 0, self.__width * ratio, self.__height, fill='blue')
        
        if(text==None):
            text=("%.2f"%(ratio*100))+'%'
        
        self._t = self.__canvas.create_text(int(self.__width)/2,int(self.__height)/2, text='')

        self.__canvas.itemconfigure(self._t, text=text)
        self.__root.update()

