#    gnuplotcompat.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

from Gnuplot import Data
import Gnuplot



def GGnuplotData(*data,**kwargs):
    version = False
    try:
        import sys
        if sys.version_info<=(2,6,0):
            version = True
    except:
        pass
        
    if Gnuplot.__version__.split('.')>=['1','8']:
        return Data(*data,**kwargs)
    elif version==True:
        b=kwargs.copy()
        b['with']=b['with_']
        del b['with_']
        return Data(*data,**b)
    else:
        a=0
        try:
            a=Data(*data,**kwargs)
        except:
            #switch with_ to with
            try:
                b['with']=b['with_']
                del b['with_']
                a=Data(*data,**b)
            except:
                from gibbs.tools.utils import CustomException
                raise CustomException('your python is above 2.6.0 and your gnuplot is under 1.8!  Use another viewer or update gnuplot to version 1.8 (or greater) at http://gnuplot-py.sourceforge.net/')
        return a
            
            
