#    tkprogressbar.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

import Tkinter
import time
class ProgressBar:

    # Create Progress Bar
    def __init__(self, width, height):
        self.t1=time.time()
        self.__root = Tkinter.Tk()
        #self.__root.withdraw()
        self.__root.resizable(False, False)
        self.__root.title('Progress Bar')
        self.__canvas = Tkinter.Canvas(self.__root, width=width, height=height)
        self.__canvas.grid()
        self.__width = width
        self.__height = height
        self._t = self.__canvas.create_text(int(self.__width)/2,int(self.__height)/2, text='')
        self._r = self.__canvas.create_rectangle(0, 0, self.__width * 0,self.__height, fill='blue')
        self.update(0.0)
        self.close()
        self.open()

    # Open Progress Bar
    def open(self):
        self.__root.deiconify()

    # Close Progress Bar
    def close(self):
        self.__root.withdraw()

    # Update Progress Bar
    def update(self, ratio,text=None):
        if ((time.time()-self.t1)<1):
            pass
        else:
            self.t1=time.time()
            self.__canvas.delete(Tkinter.ALL)
            self._r = self.__canvas.create_rectangle(0, 0, self.__width * ratio, self.__height, fill='blue')
            
            if(text==None):
                text=("%.2f"%(ratio*100))+'%'
            
            self._t = self.__canvas.create_text(int(self.__width)/2,int(self.__height)/2, text='')

            self.__canvas.itemconfigure(self._t, text=text)
            self.__root.update()

