//    QHDataFileVariableMethods.h
//    gibbs
//
//
//    Created by Thomas Cool on 1-Sept-2009.
//    Copyright 2009 Thomas Cool, R. Edwin Garcia
//    This file is part of gibbs.
//
//    gibbs is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    Foobar is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#include "stdlib.h"
#include "math.h"
#include "stdio.h"


void interpolate1d(double *xdata, int xdataLen,    //passed as a numpy array from python - represents xdata or Composition 
                     double *ydata, int ydataLen,    //passed as a numpy array from python - represents ydata or Free Energy
                     double *fxdata, int fxdataLen,  //passed as a numpy array from python - represents the xdata loaded from file
                     double *fydata, int fydataLen,  //passed as a numpy array from python - represents the xdata loaded from file
                     int N,                         //Number of the phase - concretely, where to insert the interpolated data
                     int Nx,                        //Number of samplings across xdata - should correspond to xdataLen/(total Number of Phases)
                     int add                        //Determines if the energy should be added in addition to the existing data or not
                     );
void interpolate2d(double *xdata, int xdataLen,    //passed as a numpy array from python - represents xdata or Composition 
                   double *ydata, int ydataLen,    //passed as a numpy array from python - represents ydata or Free Energy
                   double *fxdataU, int fxdataLenU,  //passed as a numpy array from python - represents the xdata loaded from file
                   double *fydataU, int fydataLenU,  //passed as a numpy array from python - represents the ydata loaded from file for the below
                   double *fxdataA, int fxdataLenA,
                   double *fydataA, int fydataLenA,
                   double below, double above, double val,
                   int N,                         //Number of the phase - concretely, where to insert the interpolated data
                   int Nx,                        //Number of samplings across xdata - should correspond to xdataLen/(total Number of Phases)
                   int add                        //Determines if the energy should be added in addition to the existing data or not
                   );
