//    QHIdealFreeEnergyC.c
//    gibbs
//
//
//    Created by Thomas Cool on 1-Sept-2009.
//    Copyright 2009 Thomas Cool, R. Edwin Garcia
//    This file is part of gibbs.
//
//    gibbs is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    Foobar is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

#include "QHIdealFreeEnergyC.h"

double xlogx (double a)
{
	
	if  (a==0.0)
	{//printf("!!");
        return 0;}
	else if (a == 1.0)
	{	//printf("@@");
        return 0;}
	else if( a>0 && a<1)
		//printf(" value %f %f\n",a, log(a));
		return a*log(a);
	return 0.0;
}
double getDouble (double *a,int b)
{
	return a[b];
}
void setDouble(double *a, int index, double value)
{
	a[index]=value;
	//return 0;
	
}
int calculateFreeEnergy(double *points,int len, double *freeEnergy,int lenn, int nb_pts, int elt_number, ideal_structP phase, double Temp, int add )
{
	double R=8.314;
	int i;
	for(i=0;i<nb_pts;i++)
	{
		int index = i + elt_number*nb_pts;
        double value;
		if(i==(nb_pts-1))
		{
			value= phase.delta_Hb-(Temp*phase.delta_Hb/phase.temp_m_b);
		}
		else
		{
			value = R*Temp* (xlogx(points[index])+xlogx(1.0-points[index]) )+ (1.0-points[index])*(phase.delta_Ha - Temp*phase.delta_Ha/phase.temp_m_a)+points[index]*(phase.delta_Hb-Temp*phase.delta_Hb/phase.temp_m_b);
            //printf("%lf %lf\n",points[index],freeEnergy[index]);
		}
        if (add==1) { freeEnergy[index] += value;}
        else        { freeEnergy[index] =  value;}

	}
	return 0;
}
ideal_structP setPhase(double delta_Ha, double delta_Hb, double temp_m_a, double temp_m_b)
{
	ideal_structP b;
	b.delta_Ha=delta_Ha;
	b.delta_Hb=delta_Hb;
	b.temp_m_a=temp_m_a;
	b.temp_m_b=temp_m_b;

	return b;
}
