#    idealfreeenergyvariable.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

from gibbs.variables.variablec import VariableC
import QHIdealFreeEnergyC as QHifeC

class IdealFreeEnergyVariable(VariableC):
    def __init__(self,delta_Ha,delta_Hb,Tma,Tmb,**kwargs):
        VariableC.__init__(self,**kwargs)
        self.delta_Ha=delta_Ha
        self.delta_Hb=delta_Hb
        self.Tma=Tma
        self.Tmb=Tmb
    def __copy__(self):
        return IdealFreeEnergyVariable(self.delta_Ha,self.delta_Hb,self.Tma,self.Tmb,**self.info)
        
    def evalf(self,freeEnergyArray,points,arraylength,xsteps,phaseNumber,yVal,add=0,**kwargs):
#        print self.delta_Ha,self.delta_Hb,self.omega,self.Tma,self.Tmb,self.omega
        self.struct=QHifeC.setPhase(self.delta_Ha,self.delta_Hb,self.Tma,self.Tmb)
        if add!=0:
            add=1
        QHifeC.calculateFreeEnergy(points,freeEnergyArray,xsteps, phaseNumber,self.struct,float(yVal),add)
        
    def __str__(self):
        return 'IdealFreeEnergyVariable(DHa=%s,DHb=%s,Tma=%s,Tmb=%s)'%(self.delta_Ha,self.delta_Hb,self.Tma,self.Tmb)