//    QHTernaryRegularFreeEnergy.h
//    gibbs
//
//
//    Created by Thomas Cool on 1-Sept-2009.
//    Copyright 2009 Thomas Cool, R. Edwin Garcia
//    This file is part of gibbs.
//
//    gibbs is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    Foobar is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.


#include "stdlib.h"
#include "math.h"

struct tern_reg_structP
{
    double Tma;
    double Tmb;
    double Tmc;
    double delta_Ha;
    double delta_Hb;
    double delta_Hc;
	double omega_ot;        //Omega_{12}
    double omega_tth;       //Omega_{23}
    double omega_oth;       //Omega_{13}
    double omega_otth;      //Omega_{123}
};
typedef struct tern_reg_structP tern_reg_structP;

/***********************************
 / calculates the free energies for certain materials and puts them in the proper free energy array
 / points				array containing all the free energies for the materials		(see: getPointsArray)
 / freeEnergy			array to fill initialized with same amount of elements as points
 / nb_pts				is the total number of data points per material (ex: 200)
 / elt_number			number of the material (should not be bigger than nb_elements in getPointsArray
 / totalmax				is number of points for which points is malloc'ed.				(see: getPointsArray)
 **********************************/
//extern int calculateFreeEnergy(double *points, double *freeEnergy, int totalmax, int nb_pts, int elt_numbers, reg_structP phase, double Temp, int add );
extern int calculateFreeEnergy(double *points,int len, double *freeEnergy, int lenn, double x_two, int nb_pts, int elt_number, tern_reg_structP phase, double Temp, int add );
int calculateFreeEnergy_two(double *points,int len, double *freeEnergy, int lenn, double x_two, int nb_pts, int elt_number, tern_reg_structP phase, double Temp, int add );
double calcValue(double x_one, double x_two, double x_three, double Temp, double R, tern_reg_structP phase);
extern int calculateFreeEnergy_two(double *points,int len, double *freeEnergy, int lenn, double x_two, int nb_pts, int elt_number, tern_reg_structP phase, double Temp, int add );
extern int calculateFreeEnergy_one(double *points,int len, double *freeEnergy, int lenn, double x_one, int nb_pts, int elt_number, tern_reg_structP phase, double Temp, int add );
extern int calculateFreeEnergy_three(double *points,int len, double *freeEnergy, int lenn, double x_three, int nb_pts, int elt_number, tern_reg_structP phase, double Temp, int add );

extern tern_reg_structP setPhase(double Tma, double Tmb, double Tmc,
                                 double delta_Ha, double delta_Hb, double delta_Hc,
                                 double omega_ot,double omega_tth,double omega_oth,
                                 double omega_otth);