#    variable.py
#    gibbs
#
#
#    Created by Thomas Cool on 1-Sept-2009.
#    Copyright 2009 Thomas Cool, R. Edwin Garcia
#    This file is part of gibbs.
#
#    gibbs is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
#

class Variable(object):
#	def __new__(cls, *p, **k):
#        a = object.__new__(cls)
#        print 'hello'
#        return a
#    
    def __new__(cls, *p, **k):
        a=object.__new__(cls)
        return a
    def __init__(self,list=None,**kwargs):
        self.list=list
        self.info={}
        self._parseKwargs(**kwargs)
        
    def copy(self):
        return self.__copy__()
    
    def __copy__(self):
        return Variable(list=self.list,**self.info)
        
    def _parseKwargs(self,**kwargs):
        if range in kwargs.keys() and isinstance(kwargs['range'],list) and len(kwargs['range'])==2:
            self.info['range']=kwargs['range']
            
        
    def __add__(self,other):
        from gibbs.variables import PyVariable
        if self.list == None:
            if isinstance(self,PyVariable) and isinstance(other,PyVariable):
                return PyVariable(self.object+other.object)
            else:
                return Variable(list=[self,other])
        else:
            newList=self.list[:]
            if isinstance(other,Variable):
                if other.list==None:
                    newList.append(other)
                else:
                    newList.extend(other.list)
            return Variable(list=newList)
            
    def evalf(self,**kwargs):
        for i in range(len(self.list)):
            if i == 0:
                self.list[i].evalf(add=0,**kwargs)#freeEnergyArray,phase,nb_elements,**kwargs)
            else:
                self.list[i].evalf(add=1,**kwargs)
                
    def __str__(self):
        if len(self.list)==None:
            return 'Empty Variable'
        else:
            a=[]
            for i in range(len(self.list)):
                a.append(self.list[i].__str__())
        return ' + '.join(a)
        
    def __repr__(self):
        return self.__str__()
        
    def __getattr__(self,name):
        from gibbs.variables import PyVariable
        if isinstance(self,PyVariable):
            return PyVariable(getattr(self,name))
        else:
            from gibbs.tools.utils import CustomException
            raise CustomException("you can only do symbolics with PyVariables For Now")

        