#
#  matplotlibTernaryViewer.py
#  gibbs
#
#  Created by Thomas Cool on 10/27/09.
#  Copyright (c) 2009 Thomas Cool. All rights reserved.
#

from gibbs.viewers.matplotlib.matplotlibViewer import MatplotlibViewer


class MatplotlibTernaryViewer(MatplotlibViewer):
    def __init__(self,vars=None,limits=None,title=None,figureNumber=1,ticks=10,**kwargs):
        MatplotlibViewer.__init__(self,vars=None,limits=None,title=None,figureNumber=1,**kwargs)
        self.optionsList.extend(['ticks','axes_colors'])
        self.setOptions(ticks=ticks,**kwargs)

    def _create_subplot(self,fig,**kwargs):
        try:
            subplot=kwargs['subplot']
        except:
            subplot='111'
        figspace=var.getOptions('figspace')
        if figspace == None:
            figspace=[0.7,0.5]
        fig.subplots_adjust(hspace=figspace[0],wspace=figspace[1])
        ax=fig.add_subplot(subplot)
        return ax
        
    def _createTriangularSubplot(self,ax):
        axes_colors=self.getOption('axes_colors')
        if type(axes_colors)!=type([]) or len(axes_colors)!=3:
            pass
            
        
    def plot(self,**kwargs):
        from numpy import cos,sin,pi,array
        from pylab import draw,show,figure
        self.setOptions(**kwargs)
        import pylab as plt
        var=self.getOption('vars')
        if type(var)!=type(array([])):#var!=None and var.type() in ['1Dimensional','2Dimensional']:
            MatplotlibViewer.__plot__(**kwargs)
        else:
            ticks=self.getOption('ticks')
#            if var.type() == 'Ternary':
            fig=plt.figure(self.getOption('figureNumber'))
            fig.clear()
            fig.subplots_adjust(hspace=0.7, wspace=0.5)
            
            ax=fig.add_subplot(111)
            ax.clear()
            try:
                ax.set_title(kwargs['title'])
            except:
                pass
            x=[0,0.5,1,0]
            y=[0,sin(pi/3),0,0]
            ax.plot(x,y,'k')
            ax.set_axis_off()
#            ax.set_xticks([])
#            ax.set_yticks([])
            ax.set_ylim([min(y)-0.1,max(y)+0.1])
            ax.set_xlim([min(x)-0.1,max(x)+0.1])
            ax.text(0.5,min(y)-0.7,'$x_1$',color='r',horizontalalignment='center')
            ax.text(min(x)+0.1,(max(y)-min(y))/2.0,'$x_2$',color='b',horizontalalignment='center',rotation=60)
            ax.text(max(x)-0.1,(max(y)-min(y))/2.0,'$x_3$',color='m',horizontalalignment='center',rotation=300)
            xrange=max(x)-min(x)
            for i in range(ticks+1):
                index=float(i)*xrange/ticks
                ax.plot([index,index],[min(x),min(x)-0.01],'k')
                ax.text(index,min(x)-0.04,float(i)/ticks,color='r',horizontalalignment='center')
            for i in range(ticks+1):
                yindex=float(i)*sin(pi/3)/ticks
                xindex=float(i)*cos(pi/3)/ticks
                ax.plot([xindex,xindex-0.01*cos(pi/6)],[yindex,yindex+0.01*sin(pi/6)],'k')
                ax.text(xindex-0.01*cos(pi/6),yindex+0.01*sin(pi/6),str(1.0-float(i)/ticks),color='b',horizontalalignment='right')
                ax.text(max(x)-(xindex-0.01*cos(pi/6)),yindex+0.01*sin(pi/6),str(float(i)/ticks),color='m')
                ax.plot([max(x)-xindex,max(x)-(xindex-0.01*cos(pi/6))],[yindex,yindex+0.01*sin(pi/6)],'k')
                ax.plot([xindex,max(x)-xindex],[yindex,yindex],':m')
                ax.plot([xindex,float(i)*xrange/ticks],[yindex,min(x)],':b')
                ax.plot([max(x)-xindex,max(x)-float(i)*xrange/ticks],[yindex,min(x)],':r')
                
                
            #x,y
            yval=(1-var[:,0]-var[:,1])*(max(y)-min(y))
            xval=var[:,0]+(1-var[:,0]-var[:,1])*cos(pi/3)
            
            #x,z
            #yval=var[:,1]*(max(y)-min(y))
            #xval=var[:,0]+(var[:,1])*cos(pi/3)

            for i in range(len(var)):
                ax.plot(xval,yval,'.k')
                
            draw()
            self.a='a'
            self.fig=fig
                        