from gibbs.viewers.matplotlib.matplotlibViewer import MatplotlibViewer
from gibbs.solvers import SolverCore


class MatplotlibLinesViewer(MatplotlibViewer):
    def __init__(self,vars=None,limits=None,title=None,figureNumber=1,**kwargs):
        MatplotlibViewer.__init__(self,vars,limits,title)
        self.setOptions(figureNumber=figureNumber,**kwargs)
        
    def plot(self,**kwargs):
        
        self.setOptions(**kwargs)
        import pylab as plt
        a=plt.figure(self.getOption('figureNumber'))
        try:
            z=kwargs['clear']
            if z:
                a.clear()
        except:
            pass
                
        try:
            subplot=kwargs['subplot']
        except:
            a.clear()
            subplot='111'
        ax=a.add_subplot(subplot)
        ax.clear()
        var=self.getOption('vars')
        if isinstance(var,SolverCore):
            if var.type()=='1Dimensional':
                for i in range(len(var.DG)):

                    a=i*var.steps
                    b=i*var.steps+var.steps

                    ax.plot(var.P[a:b],var.L[a:b],color=self.getColor(i))

                    try:
                        l=len(var.Px)/2
                        for i in range(l):
                            Px=[var.Px[i*2],var.Px[i*2+1]]
                            Py=[var.Py[i*2],var.Py[i*2+1]]
                            ax.plot(Px,Py,color='r')                        
                    except:
                        pass
                    ax.set_xlim(self.getLimits()[0:2])
                    ax.set_ylim(self.getLimits()[2:4])
        plt.draw()

                
        
        
        
        
        