from gibbs.solvers import SolverCore

class Viewer:
    '''
    Default Viewer Class
    Should not be called by end user
    '''
    def __init__(self, vars=None,verbose=False,extraOptions=None, **kwargs):
        '''
            vars   = the solver instance
            limits = list in the following form: [xmin,xmax,ymin,ymax]
            kwargs = see setOptions
        '''
        self.optionsList=['xlabel','ylabel','title','limits','vars','colorList']
        if verbose==True:
            self.verbose=True
        else:
            self.verbose=False
        if type(extraOptions)==type([]):
            self.options.extend(extraOptions)
        defaultoptions={'title':'Gibbs Plot'}
        self.options={}
        self.setOptions(**defaultoptions)
        self.setOptions(vars=vars,**kwargs)

        
        
        
    def setOptions(self,**kwargs):
        ''' 
        Setting the Viewer options
        Acceptance of keys depends on the viewer itself
        default keys are:
            xlabel: label on the x-axis
            ylabel: label on the y-axis
            title : title
        '''
        for i in kwargs.keys():
            if i=='vars':
                self.vars=kwargs[i]
            elif i in self.optionsList:
                self.options[i]=kwargs[i]
            elif self.verbose:
                print 'option %s is not supported by this viewer, ignoring' % i
                
    def getOption(self,key,type='str'):
        if type not in ['str','int','float']:
            type='str'
        try:
            if key=='vars':
                return self.vars
            optionR=self.options[key]
        except:
            if self.verbose:
                print 'option for key: %s not set'%key
            optionR=None
            
        return optionR
        
    def checkExtension(self,extension=None):
        if extension in ['ps','eps','png','gif','jpg','tiff','pdf']:
            return extension
        else:
            return 'eps'
            
    def getFilePath(self,file=None,overwrite=False,number_length=4,pad=True,**kwargs):
        #try:
        import os
        from gibbs.tools import _mkdir
        
        if file:
            title=file
        else:
            title='Gibbs Plot.eps'
            
        if title.find(os.sep)!=-1:
            b=title.split(os.sep)
            Ntitle=b[-1]
            path=title[:-len(Ntitle)]
        else:
            Ntitle=title
            path=None
            
        if Ntitle.find('.')!=-1 and Ntitle.find('.')!=(len(Ntitle)-1):
            b=title.split('.')
            ext=b[-1]
            Btitle=Ntitle[:-len(ext)-1]
            ext=self.checkExtension(ext)
        elif Ntitle.find==-1:
            Btitle=Ntitle[:-1]
            ext='eps'
        else:
            Btitle=Ntitle
            ext='eps'
        
        

            
        if path is not None:
            _mkdir(path)
            path=path
            if path[-1]==os.sep:
                path=path[:-1]
            if path[0]!=os.sep:
                path=os.getcwd()+os.sep+path
                
            try:
                names=os.listdir(path)
            except:
                raise CustomException(('save folder %s is invalid' % path))
        else:
            path=os.getcwd()
            names=os.listdir(path)
        
        if Btitle==None:
            Btitle='Gibbs_Image'
            
        if ext[0]!='.':
            ext  = '.'+ext
            
        if overwrite==False:
            if (Btitle +ext) in names:
                found=False
                i=0
                while found==False:
                    if pad==True:
                        istr = str((number_length-len(str(i)))*'0')+str(i)
                    else:
                        istr = str(i)
                    tempTitle=Btitle+'_'+istr
                    if (tempTitle +ext) not in names:
                        Btitle=tempTitle
                        found=True
                    else:
                        i+=1
                        

        savestring = path+os.sep+Btitle+ext
        return savestring
#        except:
#            return file
            